define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {

        index: function () {
            $('.btn-add').data('area',['85%','85%']);
            $('.btn-edit').data('area',['85%','85%']);
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'teacher/practice/index' + location.search,
                    add_url: 'teacher/practice/add',
                    edit_url: 'teacher/practice/edit',
                    del_url: 'teacher/practice/del',
                    multi_url: 'teacher/practice/multi',
                    import_url: 'teacher/practice/import',
                    table: 'teacher_collection',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'exam_collection_id',
                sortName: 'exam_collection_id',
                fixedColumns: true,
                fixedRightNumber: 1,
                searchFormVisible:true,
                columns: [
                    [
                        {checkbox: true},
                        {field: 'exam_collection_id', title: __('编号')},
                        {field: 'sim_type', title: __('Sim_type'),searchList:{"0001":"FZD04B型侦毒器","0002":"FZB006型毒剂报警器","0003":"防化兵用毒剂报警器"},formatter: Table.api.formatter.simtype},
                        {field: 'question_setting_method', title: __('Question_setting_method'),searchList:{"1":"系统随机","2":"教师自选","3":"任务自选"},formatter: Table.api.formatter.simmethod},
                        {field: 'exam_collection_type', title: __('Exam_collection_type'),operate: false,formatter: function (value, row, index) {
                                return '练习';
                            }
                        },
                        {
                            field: 'exam_collection_state',searchList:{"2":"打开","3":"关闭"},
                            title: __('Exam_collection_state'),
                            align: 'center',
                            table: table,
                            formatter: Table.api.formatter.collectonstate
                        },
                        {field: 'exam_collection_name', title: __('Exam_collection_name'), operate: 'LIKE', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                        // {field: 'task_id', title: __('Task_id')},
                        {field: 'limit_duration', title: __('Limit_duration')},
                        {field: 'start_time', title: __('Start_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        {field: 'end_time', title: __('End_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        // {field: 'create_user_id', title: __('Create_user_id')},
                        {field: 'create_by', title: __('Create_by'), operate: 'LIKE'},
                        {field: 'createtime', title: __('Create_time'),  operate:'RANGE', addclass:'datetimerange', autocomplete:false,formatter: Table.api.formatter.datetime},
                        // {field: 'update_by', title: __('Update_by'), operate: 'LIKE'},
                        // {field: 'update_time', title: __('Update_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        // {field: 'remark', title: __('Remark'), operate: 'LIKE', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate,
                            // formatter: Table.api.formatter.operate
                            formatter: Table.api.formatter.buttons,
                            buttons: [
                                {
                                    name: 'dispatch',
                                    text: '',
                                    icon: 'fa fa-pencil',
                                    title: '编辑',
                                    classname: 'btn btn-success btn-xs btn-magic btn-dialog',
                                    extend: 'data-area=\'["85%","85%"]\'',
                                    url: 'teacher/practice/edit',
                                },{
                                    name: 'dispatch',
                                    text: '',
                                    icon: 'fa fa-trash',
                                    title: '删除',
                                    classname: 'btn btn-danger btn-xs btn-magic btn-ajax',
                                    url: 'teacher/practice/del',
                                    confirm: '确定要删除吗？',
                                    success: function (data, ret) {
                                        $(".btn-refresh").trigger("click");
                                    },
                                    error: function (data, ret) {
                                        Layer.alert(ret.msg);
                                        return false;
                                    }
                                }
                            ],
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        persent: function () {
            Table.api.init({
                extend: {
                    index_url: 'teacher/practice/persent' + location.search,
                    indexed_url: 'teacher/practice/index' + location.search,
                    table: 'teacher_exams',
                }
            });

            var table = $("#table");
            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'exam_id',
                sortName: 'exam_id',
                toolbar: '#toolbar',
                fixedColumns: true,
                fixedRightNumber: 1,
                searchFormVisible:false,
                columns: [
                    [
                        // {checkbox: true},
                        {field: '', title: __('更换件')},
                        {field: '', title: __('学员姓名')},
                        {field: '', title: __('状态')},
                        {field: 'endtime', title: __('申请时间'), formatter: Table.api.formatter.datetime, operate: false, addclass: 'datetimerange', sortable: true},
                        {field: 'operate', title: __('Operate'), table: table,
                            events: Table.api.events.operate,
                            // formatter: Table.api.formatter.operate
                            formatter: Table.api.formatter.buttons,
                            buttons: [
                                // {
                                //     name: 'dispatch',
                                //     text: '',
                                //     icon: 'fa fa-pencil',
                                //     title: '编辑',
                                //     classname: 'btn btn-success btn-xs btn-magic btn-dialog',
                                //     extend: 'data-area=\'["55%","95%"]\'',
                                //     url: 'teacher/exams/edit',
                                // }
                            ],
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);



            var table1 = $("#table1");
            // 初始化表格
            table1.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.indexed_url,
                pk: 'exam_collection_id',
                sortName: 'exam_collection_id',
                toolbar: '#toolbar1',
                fixedColumns: true,
                fixedRightNumber: 1,
                searchFormVisible:false,
                columns: [
                    [
                        // {checkbox: true},
                        {field: '', title: __('座号')},
                        {field: '', title: __('模拟器状态')},
                        {field: '', title: __('学员学号')},
                        {field: '', title: __('学员姓名')},
                        {field: '', title: __('考试状态')},
                        {field: '', title: __('考试成绩')},
                        {field: '', title: __('故障现象')},
                        {field: '', title: __('故障部位')},
                        {field: '', title: __('排除方法')},
                        {field: 'operate', title: __('Operate'), table: table1,
                            events: Table.api.events.operate,
                            // formatter: Table.api.formatter.operate
                            formatter: Table.api.formatter.buttons,
                            buttons: [
                                // {
                                //     name: 'dispatch',
                                //     text: '',
                                //     icon: 'fa fa-pencil',
                                //     title: '编辑',
                                //     classname: 'btn btn-success btn-xs btn-magic btn-dialog',
                                //     extend: 'data-area=\'["55%","95%"]\'',
                                //     url: 'teacher/exams/edit',
                                // }
                            ],
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table1);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {

                Table.api.init({
                    extend: {
                        index_url: 'department/admin/departadmintotal' + location.search,
                    }
                });
                var table = $("#table1");
                // 初始化表格
                table.bootstrapTable({
                    url: $.fn.bootstrapTable.defaults.extend.index_url,
                    pk: 'id',
                    sortName: 'id',
                    fixedColumns: true,
                    fixedRightNumber: 1,
                    searchFormVisible:false,
                    Search:false,
                    columns: [
                        [
                            {checkbox: true},
                            {field: 'department_name', title: __('区队名称'), operate: false,width: '400px', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                            {field: 'department_admin_count', title: __('全部人员数量'),operate: false},
                        ]
                    ]
                });

                // 为表格绑定事件
                Table.api.bindevent(table);


                $("input[name='btSelectAll']").click(function () {
                    var ids = Table.api.selectedids(table);
                    console.log(ids);
                    $(".depart_ids").val(ids);
                });


                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});
